import sidebar from './sidebar';
import collect from './collect';
import { FETCH_START, FETCH_DONE } from './mutation-types';

let fetchCount = 0;
const state = () => ({
  loading: false,
});

const getters = {
  loading: state => state.loading,
};

const actions = {
  fetchStart({ commit }) {
    commit(FETCH_START);
  },
  fetchDone({ commit }) {
    commit(FETCH_DONE);
  },
};
const mutations = {
  [FETCH_START](state) {
    fetchCount++;
    state.loading = true;
  },
  [FETCH_DONE](state) {
    fetchCount--;
    if (fetchCount === 0) {
      state.loading = false;
    }
  },
};
export default {
  modules: {
    sidebar,
    collect,
  },
  state,
  getters,
  actions,
  mutations,
};
